/*--------------------------------------------------------------------------+
$Id$
|                                                                          |
| Copyright 2011 fortiss GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.kernel.service;

import static org.fortiss.tooling.kernel.ToolingKernelActivator.getService;

import java.util.List;

import org.eclipse.core.resources.IFile;
import org.fortiss.tooling.kernel.ToolingKernelActivator;
import org.fortiss.tooling.kernel.extension.IEclipseResourceStorageLocationProvider;
import org.fortiss.tooling.kernel.utils.ServicesUtils;

/**
 * The eclipse storage service manages model files residing in the Eclipse
 * workspace as IFile resources.
 * 
 * @see IEclipseResourceStorageLocationProvider
 * 
 * @author hoelzlf
 * @author $Author$
 * @version $Rev$
 * @ConQAT.Rating YELLOW Hash: 697ACFB0298C038B51A8EBDC362FEE7E
 */
public interface IEclipseResourceStorageService {
	/**
	 * Returns the service instance.
	 * 
	 * @deprecated use {@link ServicesUtils#getService(org.osgi.framework.Bundle, Class)} and
	 *             {@link ServicesUtils#ungetService(org.osgi.framework.Bundle, Class)}, instead.
	 *             See also {@link ToolingKernelActivator#getService(Class)} and
	 *             {@link ToolingKernelActivator#ungetService(Class)}
	 */
	@Deprecated
	public static IEclipseResourceStorageService getInstance() {
		return getService(IEclipseResourceStorageService.class);
	}

	/**
	 * Returns all model files provided by {@link IEclipseResourceStorageLocationProvider}s.
	 */
	List<IFile> getModelElementResources();
}
